/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	ScormLoCsvData
//	変更履歴
//		2006.11.24	新規作成
//
package jp.co.ntt.lms.lo.scorm;

import java.net.URLDecoder;
import jp.co.ntt.lms.lo.LOException;
import jp.co.ntt.lms.xmo.util.DebugLog;

/**
 * CSV形式のSCORM終了情報を受け取るためのクラス。
 * @author T.Kiyokawa
 *
 */
public class ScormLoCsvData extends Object{
	
	/**
	 * CSV1行分のデータ
	 */
	private String[] mCsvData ;
	
	/**
	 * CSVのエンコード
	 */
	private String mCsvEncode ;
	
	/**
	 * コンストラクタ
	 * @param csv CSV1行分のデータ
	 * @param encode エンコード
	 * 
	 * @throws LOException 処理に失敗した場合。
	 */
	public ScormLoCsvData( String[] csv, String encode ) throws LOException
	{
		// メソッド開始ログ
		DebugLog.write(getClass(),
			"HEAD ScormLoCsvData(" + csv + "," + encode + ")",
			DebugLog.ROW);
		
		// パラメータ保存
		mCsvData = csv ;
		mCsvEncode = encode ;

		// メソッド終了ログ
		DebugLog.write(getClass(),
			"TAIL ScormLoCsvData(" + csv + "," + encode + ")",
			DebugLog.ROW);

	}
	
	/**
	 * CSVから任意の列のデータを取得します。
	 * @param column 列番号
	 * @return CSVデータ
	 * @throws LOException 処理に失敗した場合。
	 */
	public String getData(int column) throws LOException
	{
		// メソッド開始ログ
		DebugLog.write(getClass(),
			"HEAD getData(" + column + ")",
			DebugLog.ROW);
		
		String ret = null ;
		
		try
		{
			ret = URLDecoder.decode( mCsvData[column], mCsvEncode ) ;
			
			if (ret != null && ret.length() == 0)
			{
				ret = null ;
			}
		}
		catch(Exception e)
		{
			DebugLog.write(getClass(), e, DebugLog.HIGHT);
			throw new LOException(e.getMessage());
		}

		// メソッド終了ログ
		DebugLog.write(getClass(),
			"TAIL getData(" + column + ")" + (ret==null?"null":"[]") ,
			DebugLog.ROW);

		return ret ;
	}
	
	/**
	 * 他のCSVデータの任意のフィールドを比較します。
	 * @param target 比較対象
	 * @param col 列番号
	 * 
	 * @throws LOException 処理に失敗した場合。
	 */
	public boolean equals(ScormLoCsvData target, int col) throws LOException
	{
		// nullであればfalse
		if ( target == null )
		{
			return false ;
		}
		
		////////////////////////////////////////////////////////////////////
		// CSVデータ比較
		String csvData1 = this.getData(col) ;
		String csvData2 = target.getData(col) ;
		
		////////////////////////////////////////////////////////////////////
		// nullチェック
		// どちらもnullであればtrue
		if ( csvData1 == null && csvData2 == null )
		{
			return true ;
		}
		
		// どちらか片方のみnullであればfalse
		if ( csvData1 == null || csvData2 == null )
		{
			return false ;
		}
		
		////////////////////////////////////////////////////////////////////
		// どちらもnullでなければ実際に比較する
		return csvData1.equals(csvData2) ;
	}

	/**
	 * toString オーバーライド
	 */
	public String toString()
	{
		String ret = "" ;
		for ( int i = 0 ; i < mCsvData.length ; i++ )
		{
			ret = ret + mCsvData[i] ;
			
			if ( i+1 < mCsvData.length )
			{
				ret = ret + "," ;
			}
		}
		
		ret = ret + "[Encode:" + mCsvEncode + "]" ;
		
		return ret ;
	}
}
